
/***************************************************************************
*   Copyright (C) 2004 by Christoph Thielecke                             *
*   crissi99@gmx.de                                                       *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

// BEGIN includes
#include <qcheckbox.h>
#include <klineedit.h>
#include <kcombobox.h>
#include <qspinbox.h>
#include <qpushbutton.h>
#include "advancedsettingsdialog.h"
// END includes

AdvancedSettingsDialog::AdvancedSettingsDialog(VpnAccountData *currentProfile, VpnAccountData::ConnectionType connectionType) : AdvancedProfileSettingsDialogBase()
{


	this->currentProfile = currentProfile;
	this->connectionType = connectionType;
	this->buttonHelp->hide();

	LocalPortCheckbox->setEnabled( false );
	IkeGroupCheckbox->setEnabled( false );
	PerfectForwardSecrecyCombobox->setEnabled( false );
	SingleDesCheckbox->setEnabled( false );
	NtDomainNameCheckbox->setEnabled( false );
	LocalPortSpinbox->setEnabled( false );
	ApplicationVersionLineedit->setEnabled( false );
	NtDomainNameLineedit->setEnabled( false );
	PerfectForwardSecurityCheckbox->setEnabled( false );
	IkeGroupCombobox->setEnabled( false );
	ApplicationVersionCheckbox->setEnabled( false );
	UseGlobalIpsecSecretCheckbox->setEnabled( false );
	RefuseEapCheckbox->setEnabled( false );
	requireMppeCheckbox->setEnabled( false );
	Refuse128BitEncryptionCheckbox->setEnabled(false );
	Refuse40BitEncryptionCheckbox->setEnabled( false );
	DnsServerCheckbox->setEnabled( false );
	DnsServerLineedit->setEnabled( false );
	AllowStatefulModeCheckbox->setEnabled( false );
	GetDnsFromPeerCheckbox->setEnabled( false );
	IkeGroupCheckbox->setEnabled( false );
	UdpPortSpinbox->setEnabled( false );
	UseUdpCheckbox->setEnabled( false );
	UdpPortCheckbox->setEnabled( false );
	UseNoBsdCompCheckbox->setEnabled( false );
	UseNoDeflateCheckbox->setEnabled( false );
	ReplaceDefaultRouteCheckbox->setEnabled( false );
	SetDefaultRouteCheckbox->setEnabled( false );

	IkeGroupCombobox->insertItem( "dh1", 0 );
	IkeGroupCombobox->insertItem( "dh2", 1 );
	IkeGroupCombobox->insertItem( "dh5", 2 );

	PerfectForwardSecrecyCombobox->insertItem( "server", 0 );
	PerfectForwardSecrecyCombobox->insertItem( "nopfs", 1 );
	PerfectForwardSecrecyCombobox->insertItem( "dh1", 2 );
	PerfectForwardSecrecyCombobox->insertItem( "dh2", 3 );
	PerfectForwardSecrecyCombobox->insertItem( "dh5", 4 );

	ApplicationVersionLineedit->setText( "Cisco Systems VPN Client 0.2-rm+zomb.1:Linux" );

	AdvancedSettingsCheckbox->setChecked(currentProfile->getUseAdvancedSettings());
	this->advancedSettingsToggled();
}


AdvancedSettingsDialog::~AdvancedSettingsDialog() {}

void AdvancedSettingsDialog::advancedSettingsToggled()
{
	LocalPortCheckbox->setEnabled( false );
	IkeGroupCheckbox->setEnabled( false );
	PerfectForwardSecrecyCombobox->setEnabled( false );
	SingleDesCheckbox->setEnabled( false );
	NtDomainNameCheckbox->setEnabled( false );
	LocalPortSpinbox->setEnabled( false );
	ApplicationVersionLineedit->setEnabled( false );
	NtDomainNameLineedit->setEnabled( false );
	PerfectForwardSecurityCheckbox->setEnabled( false );
	IkeGroupCombobox->setEnabled( false );
	ApplicationVersionCheckbox->setEnabled( false );
	UseGlobalIpsecSecretCheckbox->setEnabled( false );
	UseUdpCheckbox->setEnabled( false );
	UdpPortCheckbox->setEnabled( false );
	UdpPortSpinbox->setEnabled( false );
	RefuseEapCheckbox->setEnabled( false );
	requireMppeCheckbox->setEnabled( false );
	Refuse128BitEncryptionCheckbox->setEnabled(false );
	Refuse40BitEncryptionCheckbox->setEnabled( false );
	DnsServerCheckbox->setEnabled( false );
	DnsServerLineedit->setEnabled( false );
	AllowStatefulModeCheckbox->setEnabled( false );
	GetDnsFromPeerCheckbox->setEnabled( false );
	ReplaceDefaultRouteCheckbox->setEnabled( false );
	SetDefaultRouteCheckbox->setEnabled( false );
	if ( this->AdvancedSettingsCheckbox->isChecked() )
	{
		if (connectionType == VpnAccountData::ConnectionType(VpnAccountData::cisco))
		{
			RefuseEapCheckbox->setEnabled( false );
			requireMppeCheckbox->setEnabled( false );
			Refuse128BitEncryptionCheckbox->setEnabled(false );
			Refuse40BitEncryptionCheckbox->setEnabled( false );
			DnsServerCheckbox->setEnabled( false );

			DnsServerLineedit->setEnabled( false );


			AllowStatefulModeCheckbox->setEnabled( false );
			GetDnsFromPeerCheckbox->setEnabled( false );
			//if (currentProfile->getUseAdvancedSettings())
			//{
			LocalPortCheckbox->setEnabled( true );
			SingleDesCheckbox->setEnabled( true );
			NtDomainNameCheckbox->setEnabled( true );
			PerfectForwardSecurityCheckbox->setEnabled( true );
			ApplicationVersionCheckbox->setEnabled( true );
			UseGlobalIpsecSecretCheckbox->setEnabled( true );
			UseUdpCheckbox->setEnabled( true );
			UdpPortCheckbox->setEnabled( true );
			//UdpPortSpinbox->setEnabled( true );
			//}

		}
		else if (connectionType == VpnAccountData::ConnectionType(VpnAccountData::racoon))
		{
			LocalPortCheckbox->setEnabled( false );
			IkeGroupCheckbox->setEnabled( false );
			PerfectForwardSecrecyCombobox->setEnabled( false );
			SingleDesCheckbox->setEnabled( false );
			NtDomainNameCheckbox->setEnabled( false );
			LocalPortSpinbox->setEnabled( false );
			ApplicationVersionLineedit->setEnabled( false );
			NtDomainNameLineedit->setEnabled( false );
			PerfectForwardSecurityCheckbox->setEnabled( false );
			IkeGroupCombobox->setEnabled( false );
			ApplicationVersionCheckbox->setEnabled( false );
			UseGlobalIpsecSecretCheckbox->setEnabled( false );
			RefuseEapCheckbox->setEnabled( false );
			requireMppeCheckbox->setEnabled( false );
			Refuse128BitEncryptionCheckbox->setEnabled(false );
			Refuse40BitEncryptionCheckbox->setEnabled( false );
			DnsServerCheckbox->setEnabled( false );
			DnsServerLineedit->setEnabled( false );
			AllowStatefulModeCheckbox->setEnabled( false );
			GetDnsFromPeerCheckbox->setEnabled( false );

			IkeGroupCheckbox->setEnabled( true );
			//UdpPortSpinbox->setEnabled( true );
			UseUdpCheckbox->setEnabled( true );
			UdpPortCheckbox->setEnabled( true );

		}

		else if (connectionType == VpnAccountData::ConnectionType( VpnAccountData::pptp))
		{
			RefuseEapCheckbox->setEnabled( true );
			requireMppeCheckbox->setEnabled( true );
			Refuse128BitEncryptionCheckbox->setEnabled( true );
			Refuse40BitEncryptionCheckbox->setEnabled( true );
			DnsServerCheckbox->setEnabled( true );
			//DnsServerLineedit->setEnabled( true );
			NtDomainNameCheckbox->setEnabled( true );
			NtDomainNameLineedit->setEnabled( true );
			AllowStatefulModeCheckbox->setEnabled( true );
			GetDnsFromPeerCheckbox->setEnabled( true );
			UseNoBsdCompCheckbox->setEnabled( true );
			UseNoDeflateCheckbox->setEnabled( true );
			ReplaceDefaultRouteCheckbox->setEnabled( true );
			SetDefaultRouteCheckbox->setEnabled( true );
			MtuCheckbox->setEnabled( true );
		}
	}

	else
	{
		LocalPortCheckbox->setEnabled( false );
		IkeGroupCheckbox->setEnabled( false );
		PerfectForwardSecrecyCombobox->setEnabled( false );
		SingleDesCheckbox->setEnabled( false );
		NtDomainNameCheckbox->setEnabled( false );
		LocalPortSpinbox->setEnabled( false );
		ApplicationVersionLineedit->setEnabled( false );
		NtDomainNameLineedit->setEnabled( false );
		PerfectForwardSecurityCheckbox->setEnabled( false );
		IkeGroupCombobox->setEnabled( false );
		ApplicationVersionCheckbox->setEnabled( false );
		UseGlobalIpsecSecretCheckbox->setEnabled( false );
		UseUdpCheckbox->setEnabled( false );
		UdpPortCheckbox->setEnabled( false );
		UdpPortSpinbox->setEnabled( false );
		RefuseEapCheckbox->setEnabled( false );
		requireMppeCheckbox->setEnabled( false );
		Refuse128BitEncryptionCheckbox->setEnabled(false );
		Refuse40BitEncryptionCheckbox->setEnabled( false );
		DnsServerCheckbox->setEnabled( false );
		DnsServerLineedit->setEnabled( false );
		AllowStatefulModeCheckbox->setEnabled( false );
		GetDnsFromPeerCheckbox->setEnabled( false );
	}
}

void AdvancedSettingsDialog::domainNameToggled()
{
	if ( this->NtDomainNameCheckbox->isChecked() )
		this->NtDomainNameLineedit->setEnabled( true );
	else
		this->NtDomainNameLineedit->setEnabled( false );
}

void AdvancedSettingsDialog::applicationVersionToggled()
{
	if ( this->ApplicationVersionCheckbox->isChecked() )
		this->ApplicationVersionLineedit->setEnabled( true );
	else
		this->ApplicationVersionLineedit->setEnabled( false );
}

void AdvancedSettingsDialog::IkeGroupToggled()
{
	if ( this->IkeGroupCheckbox->isChecked() )
		this->IkeGroupCombobox->setEnabled( true );
	else
		this->IkeGroupCombobox->setEnabled( false );
}

void AdvancedSettingsDialog::perfectForwardSecurityToggled()
{
	if ( this->PerfectForwardSecurityCheckbox->isChecked() )
		this->PerfectForwardSecrecyCombobox->setEnabled( true );
	else
		this->PerfectForwardSecrecyCombobox->setEnabled( false );
}

void AdvancedSettingsDialog::singleDesToggled() {}

void AdvancedSettingsDialog::helpClicked() {}

void AdvancedSettingsDialog::localPortToggled()
{
	if ( this->LocalPortCheckbox->isChecked() )
		this->LocalPortSpinbox->setEnabled( true );
	else
		this->LocalPortSpinbox->setEnabled( false );
}

void AdvancedSettingsDialog::udpPortToggled()
{
	if ( this->UdpPortCheckbox->isChecked() )
		this->UdpPortSpinbox->setEnabled( true );
	else
		this->UdpPortSpinbox->setEnabled( false );
}

void AdvancedSettingsDialog::useDnsServerToggled()
{
	if ( this->DnsServerCheckbox->isChecked() )
		this->DnsServerLineedit->setEnabled( true );
	else
		this->DnsServerLineedit->setEnabled( false );
}

void AdvancedSettingsDialog::useUdpToggled()
{
	if ( this->UseUdpCheckbox->isChecked() )
		this->UdpPortCheckbox->setEnabled( true );
	else
		this->UdpPortCheckbox->setEnabled( false );
}

void AdvancedSettingsDialog::accept()
{
	currentProfile->setUseAdvancedSettings( this->AdvancedSettingsCheckbox->isChecked() );

	currentProfile->setNtDomainName( this->NtDomainNameLineedit->text() );

	currentProfile->setUseNtDomainName( this->NtDomainNameCheckbox->isChecked() );

	currentProfile->setApplicationVersion( this->ApplicationVersionLineedit->text() );
	currentProfile->setUseApplicationVersion( this->ApplicationVersionCheckbox->isChecked() );

	currentProfile->setIkeGroup( this->IkeGroupCombobox->currentText() );
	currentProfile->setUseIkeGroup( this->IkeGroupCheckbox->isChecked() );

	currentProfile->setPerfectForwardSecrety( this->PerfectForwardSecrecyCombobox->currentText() );
	currentProfile->setUsePerfectForwardSecrety( this->PerfectForwardSecurityCheckbox->isChecked() );

	currentProfile->setUseSingleDes( this->SingleDesCheckbox->isChecked() );

	currentProfile->setUseGlobalIpsecSecret(this->UseGlobalIpsecSecretCheckbox->isChecked() );

	currentProfile->setLocalPort( this->LocalPortSpinbox->value() );

	currentProfile->setUseLocalPort( this->LocalPortCheckbox->isChecked() );

	currentProfile->setUseUdp( this->UseUdpCheckbox->isChecked() );

	currentProfile->setUseUdpPort( this->UdpPortCheckbox->isChecked() );

	currentProfile->setUdpPort( this->UdpPortSpinbox->value());

	currentProfile->setRefuseEap(this->RefuseEapCheckbox->isChecked( ) );
	currentProfile->setRequireMppe(this->requireMppeCheckbox->isChecked()  );
	currentProfile->setRefuse128BitEncryption(this->Refuse128BitEncryptionCheckbox->isChecked( ) );
	currentProfile->setRefuse40BitEncryption(this->Refuse40BitEncryptionCheckbox->isChecked( ) );
	currentProfile->setUseGetDnsFromPeer(this->GetDnsFromPeerCheckbox->isChecked());
	currentProfile->setUseDnsServer(this->DnsServerCheckbox->isChecked( ) );
	currentProfile->setDnsServer(this->DnsServerLineedit->text( ) );

	currentProfile->setUseNtDomainName(this->NtDomainNameCheckbox->isChecked( ) );
	currentProfile->setNtDomainName(this->NtDomainNameLineedit->text( ) );

	currentProfile->setUseNoBsdComp(this->UseNoBsdCompCheckbox->isChecked());
	currentProfile->setUseNoDeflate(this->UseNoDeflateCheckbox->isChecked());

	currentProfile->setSetDefaultRoute(this->SetDefaultRouteCheckbox->isChecked());
	currentProfile->setReplaceDefaultRoute(this->ReplaceDefaultRouteCheckbox->isChecked());
	
	currentProfile->setUseMtu(this->MtuCheckbox->isChecked());
	currentProfile->setMtu(this->MtuSpinbox->value());

	QDialog::accept();
}

void AdvancedSettingsDialog::setDefaultRouteToggled()
{
	if (SetDefaultRouteCheckbox->isChecked())
		ReplaceDefaultRouteCheckbox->setEnabled(true);
	else
		ReplaceDefaultRouteCheckbox->setEnabled(false);
}

void AdvancedSettingsDialog::mtuToggled()
{
	if (MtuCheckbox->isChecked())
		MtuSpinbox->setEnabled(true);
	else
		MtuSpinbox->setEnabled(false);
}

