/***************************************************************************
*   Copyright (C) 2004 by Christoph Thielecke                             *
*   crissi99@gmx.de                                                       *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#ifndef IMPORTP12CERTIFICATEDIALOG_H
#define IMPORTP12CERTIFICATEDIALOG_H

#include "importp12certificatedialogbase.h"
#include <qprocess.h>
#include <qstring.h>
#include <qtextedit.h>

/**
@author Christoph Thielecke
*/
class ImportP12CertificateDialog : public ImportP12CertificateDialogBase {
		Q_OBJECT
	public:
		ImportP12CertificateDialog(QTextEdit *LogOutput);

		~ImportP12CertificateDialog();
		void canAccept();
		QString filename;
		QString racooncertpath;
		QString importpassword;
		QString privatekeypassword;
		QString privatekeyagainpassword;
		QString pathToOpenSSL;
		QString certHash;
		QString certName;
		bool importOk;
		bool doHash;
		QProcess *ImportProcess;
		
protected:
		 QTextEdit *LogOutput;


	public slots:
		void accept();
		void exit();
	
	private slots:
		void readFromStdout_import();
		void readFromStderr_import();
		void doLink();
		void doCacert();
		void doPrivateKey();
		void doCreateHash();
		void typeToggeled(const QString& type);
};

#endif
