/***************************************************************************
*   Copyright (C) 2004 by Christoph Thielecke                             *
*   crissi99@gmx.de                                                       *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#include "preferencesdialog.h"
#include <qtabwidget.h>
#include <qpushbutton.h>
#include <klocale.h>
#include <qcheckbox.h>
#include <qspinbox.h>
#include <kurlrequester.h>
#include <kcolordialog.h>
#include <qlabel.h>

PreferencesDialog::PreferencesDialog( QPtrList<VpnAccountData> *AccountList, QTextEdit *LogOutput, int KVpncDebugLevel, VpnAccountData *currentProfile, QWidget* parent, const char* name, bool modal, WFlags fl ) : PreferencesDialogBase( parent, name, modal, fl ) {
	this->AccountList = AccountList;
	this->LogOutput = LogOutput;
	this->currentProfile = currentProfile;
	this->KVpncDebugLevel = KVpncDebugLevel;

// 	ErrorLogLabel->setBackgroundMode(Qt::FixedColor );
// 	ErrorLogLabel->setBackgroundMode(Qt::FixedColor );
// 	ErrorLogLabel->setBackgroundMode(Qt::FixedColor );
// 	ErrorLogLabel->setBackgroundMode(Qt::FixedColor );
	
	MyprofileWidget = new ProfileWidget( AccountList, LogOutput, KVpncDebugLevel, currentProfile );
	tabWidget3->addTab( MyprofileWidget, i18n( "Connection profiles" ) );
	//	MyprofileWidget->show();

	connect( buttonOk, SIGNAL( clicked () ), this, SLOT( okClicked() ) );
	connect( buttonCancel, SIGNAL( clicked () ), this, SLOT( reject() ) );
	connect( ProgramsInPathcheckBox, SIGNAL ( toggled( bool ) ), this, SLOT( programsInPathToggled( bool ) ) );

	programsInPathToggled(true);
	useColorizedLogOutputToggled();

}

void PreferencesDialog::okClicked() {
	MyprofileWidget->saveSessionClicked();
	close();
}

void PreferencesDialog::programsInPathToggled( bool ) 
{
	if ( ProgramsInPathcheckBox->isChecked() ) {
		//spinVpncDebugLevel->setEnabled( false );
		VpncPathInput->setEnabled( false );
		FreeswanPathInput->setEnabled( false );
		//spinRacoonDebugLevel->setEnabled( false );
		SetkeyPathInput->setEnabled( false );
		RacoonPathInput->setEnabled( false );
		OpenSSLPathInput->setEnabled( false );
		IptablesPathInput->setEnabled( false );
		PppdPathInput->setEnabled( false );
	} else {
		//spinVpncDebugLevel->setEnabled( true );
		VpncPathInput->setEnabled( true );
		FreeswanPathInput->setEnabled( true );
		//spinRacoonDebugLevel->setEnabled( true );
		SetkeyPathInput->setEnabled( true );
		RacoonPathInput->setEnabled( true );
		OpenSSLPathInput->setEnabled( true );
		IptablesPathInput->setEnabled( true );
		PppdPathInput->setEnabled( true );
	}
}


void PreferencesDialog::errorLogColorClicked()
{
	int result = KColorDialog::getColor( ErrorLogColor );
  if ( result == KColorDialog::Accepted )
		ErrorLogLabel->setPaletteBackgroundColor (ErrorLogColor);
}

void PreferencesDialog::debugLogColorClicked()
{
	int result = KColorDialog::getColor( DebugLogColor );
  if ( result == KColorDialog::Accepted )
	DebugLogLabel->setPaletteBackgroundColor (DebugLogColor);
}


void PreferencesDialog::infoLogColorClicked()
{
	int result = KColorDialog::getColor( InfoLogColor );
  if ( result == KColorDialog::Accepted )
	InfoLogLabel->setPaletteBackgroundColor (InfoLogColor);
}

void PreferencesDialog::remoteLogColorClicked()
{
int result = KColorDialog::getColor( RemoteLogColor );
  if ( result == KColorDialog::Accepted )
	RemoteLogLabel->setPaletteBackgroundColor (RemoteLogColor);
}

void PreferencesDialog::successLogColorClicked()
{
int result = KColorDialog::getColor( SuccessLogColor );
  if ( result == KColorDialog::Accepted )
	SuccessLogLabel->setPaletteBackgroundColor (SuccessLogColor);
}

void PreferencesDialog::useColorizedLogOutputToggled()
{
	if (UseColorizedLogOutputcheckBox->isChecked())
		ColorGroupBox->setEnabled(true);
	else
		ColorGroupBox->setEnabled(false);
}






#include "preferencesdialog.moc"
