/***************************************************************************
 *   Copyright (C) 2004 by Christoph Thielecke                             *
 *   crissi99@gmx.de                                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "utils.h"
#include <qstring.h>
#include <iostream>
#include <qfile.h>
#include <qprocess.h>
#include <qstring.h>
#include <klocale.h>
#include <qdir.h>

Utils::Utils(QObject *parent, const char *name)
    : QObject(parent, name)
{
}


Utils::~Utils()
{
}

bool Utils::isValidIPv4Adress(QString Address)
{
  if ( Address.contains( '.' ) != 3 )
    return false;
  else
  {
    //std::cout << "test1 succeed.\n";
    QString addr = Address;
    int part0 = addr.section( '.', 0, 0 ).toInt();
    int part1 = addr.section( '.', 1, 1 ).toInt();
    int part2 = addr.section( '.', 2, 2 ).toInt();
    int part3 = addr.section( '.', 3, 3 ).toInt();

    //std::cout << "part0 " << part0 << ", part1 " << part1 <<  ", part2 " << part2 << ", part3 " << part3 << "\n";

    if ( ( part0 > 1 && part0 < 255 ) &&
         ( part1 >= 0 && part1 < 255 ) &&
         ( part2 >= 0 && part2 < 255 ) &&
         ( part3 > 0 && part3 < 255 ) )
      return true;
    else
      return false;
  }
}

bool Utils::tunDevExists()
{
  if (QFile ("/dev/net/tun").exists())
    return true;
  else
    return false;
}

bool Utils::createTunDev()
{
  createProcess = new QProcess(this);

  // step one: create directory
  if (!QDir ("/dev/net").exists())
  {
    createProcess->addArgument("mkdir");
    createProcess->addArgument("-p");
    createProcess->addArgument("/dev/net");
    connect( createProcess, SIGNAL( readyReadStdout() ), this, SLOT( readStdOutCreateTunDev() ) );
    connect( createProcess, SIGNAL( readyReadStderr() ), this, SLOT( readStdErrCreateTunDev() ) );

    if ( !createProcess->start() )
    {
      std::cerr << i18n("Unable to create tunnel device file!") << std::endl;
      return false;
    }
    else
    {
      while(createProcess->isRunning()) 
      { };
      // step two: create device node
      createProcess->clearArguments();
      createProcess->addArgument("mknod");
      createProcess->addArgument("/dev/net/tun");
      createProcess->addArgument("c");
      createProcess->addArgument("10");
      createProcess->addArgument("200");

      if ( !createProcess->start() )
      {
        std::cerr << i18n("Unable to create tunnel device file!") << std::endl;
        return false;
      }
      else
        return true;

    }

  }



}

void Utils::readStdOutCreateTunDev()
{
  QString msg = QString( createProcess->readStderr() );
  std::cout << "readStdOutCreateTunDev(): " << msg;
}
void Utils::readStdErrCreateTunDev()
{
  QString msg = QString( createProcess->readStderr() );
  std::cerr << "readStdErrCreateTunDev" << msg;

}


#include "utils.moc"
